package orm

import (
	"net/http"
	"time"

	"github.com/jinzhu/gorm"
	"gogs.carducci-dante.gov.it/karmen/core/renderer"
)

type Job struct {
	gorm.Model

	Name       string
	DocumentID uint

	Start time.Time
	End   time.Time
}

func (s *Job) GetID() uint { return s.ID }

func GetJob(args map[string]string) (interface{}, error) {
	var job Job
	if err := DB().First(&job, args["id"]).Error; err != nil {
		return nil, err
	}
	return &job, nil
}

func UpdateJob(args map[string]string, r *http.Request) (IDer, error) {
	job, err := GetJob(args)
	if err != nil {
		return nil, err
	}

	err = renderer.Decode(job, r)
	if err != nil {
		return nil, err
	}

	_, err = SaveJob(job)
	if err != nil {
		return nil, err
	}
	job, err = GetJob(args)
	if err != nil {
		return nil, err
	}
	return job.(*Job), nil
}

func SaveJob(job interface{}) (interface{}, error) {
	if err := DB().Save(job).Error; err != nil {
		return nil, err
	}
	return job, nil
}
